// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from mavros_msgs:srv/SetMavFrame.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__SRV__DETAIL__SET_MAV_FRAME__STRUCT_H_
#define MAVROS_MSGS__SRV__DETAIL__SET_MAV_FRAME__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'FRAME_GLOBAL'.
/**
  * XXX DEPRECATED
  * [[[cog:
  * from pymavlink.dialects.v20 import common
  *
  * def decl_enum(ename, pfx='', bsz=8):
  *     enum = sorted(common.enums[ename].items())
  *     enum.pop() # remove ENUM_END
  *
  *     cog.outl("# " + ename)
  * for k, e in enum:
  *         sn = e.name[len(ename) + 1:]
  * l = "uint{bsz} {pfx}{sn} = {k}".format(**locals())
  *         if e.description:
  * l += ' ' * (40 - len(l)) + ' # ' + e.description
  *         cog.outl(l)
  *
  * decl_enum('MAV_FRAME', 'FRAME_')
  * ]]]
  * MAV_FRAME
  * Global (WGS84) coordinate frame + MSL altitude. First value / x: latitude, second value / y: longitude, third value / z: positive altitude over mean sea level (MSL).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL = 0
};

/// Constant 'FRAME_LOCAL_NED'.
/**
  * Local coordinate frame, Z-down (x: North, y: East, z: Down).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_LOCAL_NED = 1
};

/// Constant 'FRAME_MISSION'.
/**
  * NOT a coordinate frame, indicates a mission command.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_MISSION = 2
};

/// Constant 'FRAME_GLOBAL_RELATIVE_ALT'.
/**
  * Global (WGS84) coordinate frame + altitude relative to the home position. First value / x: latitude, second value / y: longitude, third value / z: positive altitude with 0 being at the altitude of the home location.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL_RELATIVE_ALT = 3
};

/// Constant 'FRAME_LOCAL_ENU'.
/**
  * Local coordinate frame, Z-up (x: East, y: North, z: Up).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_LOCAL_ENU = 4
};

/// Constant 'FRAME_GLOBAL_INT'.
/**
  * Global (WGS84) coordinate frame (scaled) + MSL altitude. First value / x: latitude in degrees*1.0e-7, second value / y: longitude in degrees*1.0e-7, third value / z: positive altitude over mean sea level (MSL).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL_INT = 5
};

/// Constant 'FRAME_GLOBAL_RELATIVE_ALT_INT'.
/**
  * Global (WGS84) coordinate frame (scaled) + altitude relative to the home position. First value / x: latitude in degrees*10e-7, second value / y: longitude in degrees*10e-7, third value / z: positive altitude with 0 being at the altitude of the home location.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL_RELATIVE_ALT_INT = 6
};

/// Constant 'FRAME_LOCAL_OFFSET_NED'.
/**
  * Offset to the current local frame. Anything expressed in this frame should be added to the current local frame position.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_LOCAL_OFFSET_NED = 7
};

/// Constant 'FRAME_BODY_NED'.
/**
  * Setpoint in body NED frame. This makes sense if all position control is externalized - e.g. useful to command 2 m/s^2 acceleration to the right.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_BODY_NED = 8
};

/// Constant 'FRAME_BODY_OFFSET_NED'.
/**
  * Offset in body NED frame. This makes sense if adding setpoints to the current flight path, to avoid an obstacle - e.g. useful to command 2 m/s^2 acceleration to the east.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_BODY_OFFSET_NED = 9
};

/// Constant 'FRAME_GLOBAL_TERRAIN_ALT'.
/**
  * Global (WGS84) coordinate frame with AGL altitude (at the waypoint coordinate). First value / x: latitude in degrees, second value / y: longitude in degrees, third value / z: positive altitude in meters with 0 being at ground level in terrain model.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL_TERRAIN_ALT = 10
};

/// Constant 'FRAME_GLOBAL_TERRAIN_ALT_INT'.
/**
  * Global (WGS84) coordinate frame (scaled) with AGL altitude (at the waypoint coordinate). First value / x: latitude in degrees*10e-7, second value / y: longitude in degrees*10e-7, third value / z: positive altitude in meters with 0 being at ground level in terrain model.
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_GLOBAL_TERRAIN_ALT_INT = 11
};

/// Constant 'FRAME_BODY_FRD'.
/**
  * Body fixed frame of reference, Z-down (x: Forward, y: Right, z: Down).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_BODY_FRD = 12
};

/// Constant 'FRAME_RESERVED_13'.
/**
  * MAV_FRAME_BODY_FLU - Body fixed frame of reference, Z-up (x: Forward, y: Left, z: Up).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_13 = 13
};

/// Constant 'FRAME_RESERVED_14'.
/**
  * MAV_FRAME_MOCAP_NED - Odometry local coordinate frame of data given by a motion capture system, Z-down (x: North, y: East, z: Down).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_14 = 14
};

/// Constant 'FRAME_RESERVED_15'.
/**
  * MAV_FRAME_MOCAP_ENU - Odometry local coordinate frame of data given by a motion capture system, Z-up (x: East, y: North, z: Up).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_15 = 15
};

/// Constant 'FRAME_RESERVED_16'.
/**
  * MAV_FRAME_VISION_NED - Odometry local coordinate frame of data given by a vision estimation system, Z-down (x: North, y: East, z: Down).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_16 = 16
};

/// Constant 'FRAME_RESERVED_17'.
/**
  * MAV_FRAME_VISION_ENU - Odometry local coordinate frame of data given by a vision estimation system, Z-up (x: East, y: North, z: Up).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_17 = 17
};

/// Constant 'FRAME_RESERVED_18'.
/**
  * MAV_FRAME_ESTIM_NED - Odometry local coordinate frame of data given by an estimator running onboard the vehicle, Z-down (x: North, y: East, z: Down).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_18 = 18
};

/// Constant 'FRAME_RESERVED_19'.
/**
  * MAV_FRAME_ESTIM_ENU - Odometry local coordinate frame of data given by an estimator running onboard the vehicle, Z-up (x: East, y: North, z: Up).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_RESERVED_19 = 19
};

/// Constant 'FRAME_LOCAL_FRD'.
/**
  * Forward, Right, Down coordinate frame. This is a local frame with Z-down and arbitrary F/R alignment (i.e. not aligned with NED/earth frame).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_LOCAL_FRD = 20
};

/// Constant 'FRAME_LOCAL_FLU'.
/**
  * Forward, Left, Up coordinate frame. This is a local frame with Z-up and arbitrary F/L alignment (i.e. not aligned with ENU/earth frame).
 */
enum
{
  mavros_msgs__srv__SetMavFrame_Request__FRAME_LOCAL_FLU = 21
};

/// Struct defined in srv/SetMavFrame in the package mavros_msgs.
typedef struct mavros_msgs__srv__SetMavFrame_Request
{
  /// ]] (checksum: 013a057712ce80e0a4bffa7c5e2c05a9)
  uint8_t mav_frame;
} mavros_msgs__srv__SetMavFrame_Request;

// Struct for a sequence of mavros_msgs__srv__SetMavFrame_Request.
typedef struct mavros_msgs__srv__SetMavFrame_Request__Sequence
{
  mavros_msgs__srv__SetMavFrame_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} mavros_msgs__srv__SetMavFrame_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/SetMavFrame in the package mavros_msgs.
typedef struct mavros_msgs__srv__SetMavFrame_Response
{
  bool success;
} mavros_msgs__srv__SetMavFrame_Response;

// Struct for a sequence of mavros_msgs__srv__SetMavFrame_Response.
typedef struct mavros_msgs__srv__SetMavFrame_Response__Sequence
{
  mavros_msgs__srv__SetMavFrame_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} mavros_msgs__srv__SetMavFrame_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MAVROS_MSGS__SRV__DETAIL__SET_MAV_FRAME__STRUCT_H_
